Imports System.io
Imports System.Data
Imports System.data.OleDb
Namespace MassMailer
    Partial Class DatabaseList
        Inherits System.Web.UI.Page

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            If Not IsPostBack Then
                ViewState("FilePath") = Server.MapPath(".") & "\App_Data\"
                PickDBFileDirectory("App_Data")
            End If
        End Sub

        Private Sub PickDBFileDirectory(ByVal directoryPath As String)
            Try
                Dim bTab As New DataTable
                ' Create four typed columns in the DataTable.
                bTab.Columns.Add("DBFileName", GetType(String))
                bTab.Columns.Add("TotalEmails", GetType(String))
                bTab.Columns.Add("SentTillNow", GetType(String))
                bTab.Columns.Add("ToBeSent", GetType(String))
                bTab.Columns.Add("ToBeReject", GetType(String))
                bTab.Columns.Add("SentLastDate", GetType(String))

                Dim strFilename1 As String
                Dim directory As DirectoryInfo = New DirectoryInfo(Server.MapPath(directoryPath))
                For Each fileInfo As System.IO.FileInfo In directory.GetFiles("*.MDB")
                    strFilename1 = fileInfo.Name
                    If strFilename1 <> "SendITBlank.mdb" Then
                        ConnectAcessDatabase(fileInfo.Name)
                        Dim ToBeSent, TotEmail, SentTillNow, LastDateSent, strToBeReject As String
                        ToBeSent = GetField("SELECT COUNT(*) AS ToBeSent FROM EmailDB WHERE Sent = 'N'", "ToBeSent")
                        TotEmail = GetField("SELECT COUNT(*) AS TotEmail FROM EmailDB", "TotEmail")
                        SentTillNow = GetField("SELECT COUNT(*) AS SentTillNow FROM EmailDB WHERE Sent = 'Y'", "SentTillNow")
                        strToBeReject = GetField("SELECT COUNT(*) AS strToBeReject FROM EmailDB WHERE Sent = 'R'", "strToBeReject")
                        LastDateSent = GClass.GetDateTime(GetField("SELECT EndTime as EndTime FROM Controller", "EndTime"))
                        bTab.Rows.Add(strFilename1, TotEmail, SentTillNow, ToBeSent, strToBeReject, LastDateSent)
                    End If
                Next
                GrdDBFile.DataSource = bTab
                GrdDBFile.DataBind()
            Catch ex As Exception
                Response.Redirect("FrmError.aspx?TempError=" & ex.Message)
            End Try
        End Sub

        Protected Sub GrdDBFile_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles GrdDBFile.RowCommand
            Dim strcommant As String
            strcommant = e.CommandName
            Dim iRowIndex As Integer
            Integer.TryParse(e.CommandArgument.ToString, iRowIndex)
            Select Case strcommant
                Case "iselect"
                    CType(GrdDBFile.Rows(iRowIndex).FindControl("imgTick"), Image).Visible = True
                    Dim strFileName As String = CType(GrdDBFile.Rows(iRowIndex).FindControl("LblDBFileName"), Label).Text
                    Session("FileName") = strFileName & ".mdb"
                    PickDBFileDirectory("App_Data")
                    ConnectAcessDatabase(Session("FileName"))
                Case "iDelete"
                    Dim str As String = e.CommandArgument
                    If Session("FileName") = str Then
                        Session.Remove("FileName")
                    End If
                    Dim StrMDBFileName As String = Server.MapPath("App_Data") & "\" & str
                    System.IO.File.Delete(StrMDBFileName)
                    PickDBFileDirectory("App_Data")
                Case "iReset"
                    Dim strFileName As String = e.CommandArgument
                    ConnectAcessDatabase(strFileName)
                    ExecuteCommand("UPDATE EmailDB SET Sent='N' WHERE Sent='Y'")
                    ExecuteCommand("UPDATE EmailDB SET Sent='N' WHERE Sent='R'")
                    PickDBFileDirectory("App_Data")
                Case "iManage"
                    Dim strFileName As String = e.CommandArgument
                    Session("FileName") = strFileName
                    ConnectAcessDatabase(Session("FileName"))
                    Response.Redirect("DatabaseManage.aspx")
                Case "iDownload"
                    Dim str As String = e.CommandArgument
                    Dim StrMDBFileName As String = Server.MapPath("App_Data") & "\"
                    GClass.DownLoadFileFromServer(StrMDBFileName, str, str)
            End Select
        End Sub

        Protected Sub GrdDBFile_RowCreated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GrdDBFile.RowCreated
            Dim LnkSelect As LinkButton
            If e.Row.RowType = DataControlRowType.DataRow Then
                LnkSelect = CType(e.Row.FindControl("LnkSelect"), LinkButton)
                LnkSelect.CommandArgument = e.Row.RowIndex.ToString()
            End If
        End Sub

        Protected Sub GrdDBFile_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles GrdDBFile.RowDataBound
            Dim LnkDelete As LinkButton
            If e.Row.RowType = DataControlRowType.DataRow Then
                Dim StrDBName As String = e.Row.DataItem("DBFileName")
                If Session("FileName") Is Nothing Then
                    If e.Row.DataItem("ToBeSent") > 0 Then
                        CType(e.Row.FindControl("imgTick"), Image).Visible = True
                        Session("FileName") = StrDBName
                    End If
                Else
                    If Session("FileName") = e.Row.DataItem("DBFileName") Then
                        CType(e.Row.FindControl("imgTick"), Image).Visible = True
                        Session("FileName") = StrDBName
                    Else
                        CType(e.Row.FindControl("imgTick"), Image).Visible = False
                    End If
                End If
                CType(e.Row.FindControl("LblDBFileName"), Label).Text = StrDBName.Substring(0, StrDBName.Length - 4)
                LnkDelete = CType(e.Row.FindControl("LnkDelete"), LinkButton)
                LnkDelete.Attributes.Add("onclick", "return ConfirmDelete()")
                e.Row.Attributes.Add("onmouseover", "Grdmouseover(this, 2)")
                e.Row.Attributes.Add("onmouseout", "Grdmouseout(this, 2)")
            End If
        End Sub
        Protected Sub BtnResetAll_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BtnResetAll.Click
            Dim strFilename As String
            Dim directory As DirectoryInfo = New DirectoryInfo(Server.MapPath("App_Data"))
            For Each fileInfo As System.IO.FileInfo In directory.GetFiles("*.MDB")
                strFilename = fileInfo.Name
                If strFilename <> "SendITBlank.mdb" Then
                    ConnectAcessDatabase(fileInfo.Name)
                    ExecuteCommand("UPDATE EmailDB SET Sent='N' WHERE Sent='Y'")
                End If
            Next
            PickDBFileDirectory("App_Data")
        End Sub



        Protected Sub LnkDownload_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LnkDownload.Click
            Dim strOriginal As String = "SendITBlank.mdb"
            Dim strReplaceName As String = "SendITBlank.mdb"
            Dim StrFilePath As String = Server.MapPath("App_Data") & "\"
            GClass.DownLoadFileFromServer(StrFilePath, strOriginal, strReplaceName)
        End Sub
        Protected Sub BtnProceedForEmail_Click(sender As Object, e As EventArgs) Handles BtnProceedForEmail.Click
            If Session("FileName") Is Nothing Then
                GClass.ShowErrorMsg("Please select the Database?")
            Else
                If Session("FileName") = "" Then
                    GClass.ShowErrorMsg("Please select the Database?")
                Else
                    Maildata()
                    Response.Redirect("EmailDetail.aspx")
                End If
            End If
        End Sub

        Protected Sub BtnProceedForSMS_Click(sender As Object, e As EventArgs) Handles BtnProceedForSMS.Click
            If Session("FileName") Is Nothing Then
                GClass.ShowErrorMsg("Please select the Database?")
            Else
                If Session("FileName") = "" Then
                    GClass.ShowErrorMsg("Please select the Database?")
                Else
                    Maildata()
                    Response.Redirect("SMSDetail.aspx")
                End If
            End If
        End Sub


        Protected Sub BtnDownloadDatabase_Click(sender As Object, e As EventArgs) Handles BtnDownloadDatabase.Click
            ConnectAcessDatabase("SendITBlankCopy.mdb")
            If (FUDownloadDatabase.HasFile) Then
                Dim dd As New ExcelUpload
                dd.Synchronize(FUDownloadDatabase, ExcelUpload.ClearData.AllClear)
                Dim strOriginal As String = "SendITBlankCopy.mdb"
                Dim strReplaceName As String = "DownloadDatabase.mdb"
                Dim StrFilePath As String = Server.MapPath("App_Data") & "\"
                GClass.DownLoadFileFromServer(StrFilePath, strOriginal, strReplaceName)
            End If

        End Sub

        Protected Sub LnkDownloadExcelfile_Click(sender As Object, e As EventArgs) Handles LnkDownloadExcelfile.Click
            Dim strOriginal As String = "SampleExcel.xls"
            Dim strReplaceName As String = "SampleExcel.xls"
            Dim StrFilePath As String = Server.MapPath("DownloadExcelFile") & "\"
            GClass.DownLoadFileFromServer(StrFilePath, strOriginal, strReplaceName)
        End Sub
        Protected Sub BtnUpload_Click(sender As Object, e As EventArgs) Handles BtnUpload.Click
            Dim StrFileName As String
            StrFileName = MdbUpload.FileName
            If Not MdbUpload.HasFile Then
                GClass.ShowErrorMsg("Please select a file to upload")
            Else
                If System.IO.File.Exists(ViewState("FilePath") & StrFileName) Then
                    GClass.ShowErrorMsg("This Filename already exists, please rename your file and upload again.")
                Else
                    Dim fileExt As String = System.IO.Path.GetExtension(MdbUpload.FileName)
                    If UCase(fileExt) = ".MDB" Then
                        MdbUpload.SaveAs(ViewState("FilePath") & StrFileName)
                        PickDBFileDirectory("~/App_Data/")
                    Else
                        GClass.ShowErrorMsg("Please select a MDB file to upload")
                    End If
                End If
            End If
        End Sub

    End Class
End Namespace